var gMilitaryTime = false;
var gTestSpeed = 1;
var gSize = 198 - 50;
var pSize = 0.085 * gSize;
var gStartTime = null;
var gBaseTime = null;
var gSpeed = 1.0;
//var gFacing = -1.0; // facing south

var kSpeedRealTime = 1.0;
var kSpeedMinute = 60.0; // aka slow
var kSpeedHour = 60.0 * 60; // aka one hour per second, medium
var kSpeedDay = 60 * 60 * 24; // on day per second

var zodiacNames = new Array(
	"Aries", "Taurus", "Gemini", "Cancer", "Leo", "Virgo", "Libra", "Scorpius", "Sagittarius", "Capricorn", "Aquarius", "Pisces"
);
var planetNames = new Array(
	"Mercury", "Venus", "Mars", "Jupiter", "Saturn"
);
var zodiacImages = new Array();
var planetImages = new Array();
function setup() {
	//createGenericButton(document.getElementById("donePrefsButton"),"Done",hidePrefs,60)
	//document.getElementById("donePrefsButton").display = "none";
	// put your setup code here...
	// preload images
	//document.getElementById("location").innerText = "Location: " + Armillary.locationLatitudeString() + ", " + Armillary.locationLongitudeString();
	//drawCurrentOrrery();
	//setTimeout(drawCurrentOrrery, 0); //	let it load the symbol
	//adjustTimer();
	gWidget.Open();
}

gGlobalDefaults = Proto({_proto : protoPersistent} );
gInstanceDefaults = Proto({_proto : gGlobalDefaults, instanceName : widget.identifier,
	militaryTime : 0,
	showAltAz : 1,
	showCircles : 1,
	showConstellationLines: 1,
	showRaDec : 1,
	showEcliptic : 1,
	showMinMagnitude : 4.5
} );

// --------------------------------------------------------------------------------------------------------------------------------
gWidget = View({
	_proto : protoDrawerWidget,
	KeyEvent : function(event) {
		if (GetView('viewFrontKey')) { // have a focus
			protoDrawerWidget.KeyEvent.call(this,event);
			return;
		}
		if (event.charCode == 43)
		fasterSpeed();
		else if (event.charCode == 45)
		slowerSpeed();
		else if (event.charCode == 3)
		resetSpeed();
		else if (event.charCode = 61)
		realSpeed();
		else if (event.charCode == 32)
		stopSpeed();
		else {
			//alert('keypress' + event.charCode);
			return;
		}
		event.stopPropagation();
	},
	WidgetFocusScript : function() {
		protoDrawerWidget.WidgetFocusScript.call(this);
	},
	WidgetBlurScript : function() {
		protoDrawerWidget.WidgetBlurScript.call(this);
	}
});

// --------------------------------------------------------------------------------------------------------------------------------
gFront = View({
	_proto: protoSideFront
});
DeclareStepChild(View({_proto: protoImage, imageSrc: "Default.png"}), gFront, 'backdropImage');
DeclareStepChild(gFront, gWidget, 'frontSide');
gBack = View({
	_proto: protoSideBack
});
DeclareStepChild(gBack, gWidget, 'backSide');

protoIFlipper.viewBounds = RelBounds(0,50,13,13);
protoIFlipper.viewJustify = vjParentCenterH + vjParentCenterV;

protoHidingText = View({
	_proto: protoText,
	_mixins : [mixinSlowFader],
	ViewParentPointedScript : function(parent, event) {
		protoView.ViewParentPointedScript.call(this, parent, event);
		if (parent == this._parent) {
			// we've moved over 'front'
			this.SlowShow();
		}
	},
	ViewParentUnpointedScript : function(parent, event) {
		protoView.ViewParentPointedScript.call(this, parent, event);
		if (parent == this._parent) {
			// we've moved over 'front'
			this.SlowHide();
		}
	}
});
DeclareStepChild(View({
	_proto: protoHidingText,
	chromeStyle: 'clickInfo',
	viewBounds : RelBounds(0,-17,150,17),
	viewJustify : vjParentCenterH + vjParentCenterV + vjCenterH,
	viewFlags : protoHTMLText.viewFlags | vClickable,
	ViewClickScript : function(event) {
		stopSpeed();
		GetView('timeModal').Show();
	}

}), gFront, 'day');
DeclareStepChild(View({
	_proto: protoHidingText,
	chromeStyle: 'clickInfo',
	viewBounds : RelBounds(0,0,100,17),
	viewJustify : vjParentCenterH + vjParentCenterV + vjCenterH,
	viewFlags : protoHTMLText.viewFlags | vClickable,
	ViewClickScript : function(event) {
		stopSpeed();
		GetView('timeModal').Show();
	}
}), gFront, 'time');

DeclareStepChild(View({
	_proto: protoHidingText,
	chromeStyle : "compass",
	text: 'N',
	zIndex : 2,
	viewBounds : RelBounds(0,3,20,17),
	viewJustify : vjParentCenterH + vjCenterH
}), gFront, 'N');
DeclareStepChild(View({
	_proto: protoHidingText,
	chromeStyle : "compass",
	text: 'S',
	zIndex : 2,
	viewBounds : RelBounds(0,-34,20,17),
	viewJustify : vjParentCenterH + vjParentBottomV + vjCenterH
}), gFront, 'S');
DeclareStepChild(View({
	_proto: protoHidingText,
	chromeStyle : "compass",
	text: 'E',
	zIndex : 2,
	viewBounds : RelBounds(10,-8,20,17),
	viewJustify : vjParentCenterV + vjCenterH
}), gFront, 'E');
DeclareStepChild(View({
	_proto: protoHidingText,
	chromeStyle : "compass",
	text: 'W',
	zIndex : 2,
	viewBounds : RelBounds(-32,-8,20,17),
	viewJustify : vjParentCenterV + vjParentRightH + vjCenterH
}), gFront, 'W');

// --------------------------------------------------------------------------------------------------------------------------------
timeModal = View({
	_proto : protoModalWindow,
	viewBounds : RelBounds(0,-3,200,75),
	viewJustify : vjParentCenterH | vjParentCenterV,
	ViewShowScript : function() {
		this.SetViewAnimation(Proto({_proto: protoWipeAnimation, direction:"PanOutTop"}));
		protoModalWindow.ViewShowScript.call(this);
		SetValue('timePicker', 'date', currentDate());
		SetValue('dayPicker', 'date', currentDate());
		GetView('day').Hide();
		GetView('time').Hide();
	},
	ViewHideScript : function() {
		protoModalWindow.ViewHideScript.call(this);
		GetView('day').Show();
		GetView('time').Show();
	}
});
DeclareStepChild(timeModal, gFront, 'timeModal');
DeclareStepChild(View({_proto: protoCloseBox,
	xButtonClickScript : function() {
		var p = this._parent;
		p.SetViewAnimation(Proto({_proto: protoWipeAnimation,
			direction:"InBottom",
			FinishAnimationScript: function() {
				protoWipeAnimation.FinishAnimationScript.call(this);
				p.Close();
			}
		}));
	}
}), timeModal, 'closeBox');
//DeclareStepChild(View({_proto: protoText,
//	viewBounds: RelBounds(0,20,160, 20),
//	viewJustify: vjParentCenterH | vjParentTopV | vjCenterH,
//	chromeStyle : 'primaryInfo',
//	text : 'Set Date/Time'
//	}), timeModal, 'title');
DeclareStepChild(View({_proto: protoTimeTyper,
	viewBounds: RelBounds(0,36, protoTimeTyper.chromeWidth, protoTimeTyper.chromeHeight),
	viewJustify: vjParentTopV | vjCenterH | vjParentCenterH,
	NewTime : function(date) {
		gBaseTime.setHours(date.getHours());
		gBaseTime.setMinutes(date.getMinutes());
		GetView('armillary').Dirty();
	}
}), timeModal, 'timePicker');
DeclareStepChild(View({_proto: protoDateTyper,
	viewBounds: RelBounds(0,13, protoDateTyper.chromeWidth, protoDateTyper.chromeHeight),
	viewJustify: vjParentTopV | vjCenterH | vjParentCenterH,
	NewDate : function(date) {
		gBaseTime.setDate(date.getDate());
		gBaseTime.setMonth(date.getMonth());
		gBaseTime.setFullYear(date.getFullYear());
		GetView('armillary').Dirty();
	}
}),timeModal, 'dayPicker');






function d2r(d)
{
	d = d / 180 * Math.PI;
	return	d;
}
function r2d(r) { return r / Math.PI * 180; }
function mod360(x)
{
	if (x < 0) return (360 - (-x % 360)) % 360;
	return x % 360;
}



// --------------------------------------------------------------------------------------------------------------------------------
gArmillary = View({
	_proto: protoView,
	viewBounds: RelBounds(14,4,292,292),
	viewFlags : protoCanvas.viewFlags | vKeyable | vClickable,
	width: 292,
	height: 292,
	CreateElement : function() {
		var retval = document.createElement('embed');
		retval.setAttribute('name', "ArmillaryPlugin");
		retval.setAttribute('width', this.width);
		retval.setAttribute('height', this.height);
		retval.setAttribute('type', "x-armillary/x-armillary");
		alert("created element");
		return retval;
	},
	ViewSetupDoneScript : function() {
		this.viewElement.setShowAltAz(gInstanceDefaults.showAltAz);
		this.viewElement.setShowCircles(gInstanceDefaults.showCircles);
		this.viewElement.setShowRaDec(gInstanceDefaults.showRaDec);
		this.viewElement.setShowConstellationLines(gInstanceDefaults.showConstellationLines);
		this.viewElement.setShowEcliptic(gInstanceDefaults.showEcliptic);
		this.viewElement.setShowMinMagnitude(gInstanceDefaults.showMinMagnitude);
		this.showAltAz = this.viewElement.showAltAz();
		this.showCircles = this.viewElement.showCircles();
		this.showRaDec = this.viewElement.showRaDec();
		this.showConstellationLines = this.viewElement.showConstellationLines();
		this.showEcliptic = this.viewElement.showEcliptic();
		this.showMinMagnitude = this.viewElement.showMinMagnitude();
		this.viewElement.setCurrentDate(this.viewElement.currentDate);
		protoView.ViewSetupDoneScript.call(this);
		this.SetupIdle(60000); // redraw every minute
		this.viewElement = document.getElementById("armillary");
	},
	Dirty : function() {
		var date = currentDate();
		gLastDateDrawn = currentDate();
		document.getElementById("armillary").setCurrentDate(date.valueOf() / 1000);
		//this.viewElement.setDirty();
		if (GetView('day')) {
			SetValue('day', 'text', dayStringFromDate(date));
		}
		if (GetView('time')) {
			if (gSpeed < kSpeedHour) {
				SetValue('time', 'text', timeStringFromDate(date));
				GetView('time').Show();
			} else if (gSpeed < kSpeedDay) {
				SetValue('time', 'text', timeStringFromDate(date));
				GetView('time').Show();
			} else {
				GetView('time').Hide();
				SetValue('time', 'text', '');
			}
		}
	},
	ViewIdleScript	: function() {
		this.Dirty();
	},
	ViewChangedScript : function(slot, value) {
		alert("view changed " + slot);
		if (slot == "showAltAz") {
			document.getElementById("armillary").setShowAltAz(value)
		} else if (slot == "showCircles") {
			document.getElementById("armillary").setShowCircles(value)
		} else if (slot == "showEcliptic") {
			document.getElementById("armillary").setShowEcliptic(value)
		} else if (slot == "showRaDec") {
			document.getElementById("armillary").setShowRaDec(value)
		} else if (slot == "showConstellationLines") {
			document.getElementById("armillary").setShowConstellationLines(value)
		} else if (slot == "showMinMagnitude") {
			document.getElementById("armillary").setShowMinMagnitude(value)
		}
	}
});

DeclareStepChild(gArmillary, gFront, "armillary");




function dayStringFromDate(date)
{
	var months = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
	return date.getDate() + " " + months[date.getMonth()] + " " + date.getFullYear();
}

function timeStringFromDate(date)
{
	if (gInstanceDefaults.militaryTime)
		return date.getHours() + ":" + date.getMinutes()
	else {
		var minutes = date.getMinutes();
		if (minutes	 < 10) minutes = "0" + minutes;
		if (date.getHours() == 0)
			return "12:" + minutes + " AM";
		if (date.getHours() < 12)
			return date.getHours() + ":" + minutes + " AM";
		if (date.getHours() == 12)
			return "12:" + minutes + " PM";
		return (date.getHours() - 12) + ":" + minutes + " PM";
	}
}
function extractTimeOfDay(daystring)
{
	var date = new Date(daystring * 1000);
	//return date.toString()
	return timeStringFromDate(date);
}

var gLastDateDrawn = null;
function currentDate()
{
	if (gStartTime == null)
		return new Date;
	if (gBaseTime == null)
		gBaseTime = new Date;
	var date = new Date();
	var ms = (date.valueOf() - gStartTime.valueOf()) * gSpeed + gBaseTime.valueOf();
	return new Date(ms);
}

function adjustTimer()
{
	if (gSpeed == 0) {
		GetView('armillary').SetupIdle(null); // stop
		GetView('armillary').Dirty();// but redraw it right away to show adjustments
	} else if (gSpeed <= kSpeedRealTime) {
		GetView('armillary').SetupIdle(60000); // 1 per minute
		GetView('armillary').Dirty();// but redraw it right away to show adjustments
	} else {
		GetView('armillary').SetupIdle(1000);// 1 per second
	}
	if (gSpeed != 0) { // don't show time drawer if we are running
//		GetView('timeDrawer').HideDrawer();
	}
}
function stopHere()
{
	gBaseTime = gLastDateDrawn;
	gStartTime = new Date();
}

function resetSpeed()
{
	gSpeed = kSpeedRealTime;
	gStartTime = gBaseTime = new Date();
	adjustTimer();
}

function realSpeed()
{
	stopHere();
	gSpeed = kSpeedRealTime;
	adjustTimer();
}
function fasterSpeed()
{
	stopHere();
	if (gSpeed == 0)
		gSpeed = kSpeedRealTime;
	else if (gSpeed < kSpeedMinute)
		gSpeed = kSpeedMinute; // one minute per second, "slow"
	else if (gSpeed < kSpeedHour)
		gSpeed = kSpeedHour; // one hour per second, "medium"
	else
		gSpeed = kSpeedDay; // one day per second, "fast"
	adjustTimer();
}

function slowerSpeed()
{
	stopHere();
	if (gSpeed >= kSpeedDay)
		gSpeed = kSpeedHour; // one minute per second, "slow"
	else if (gSpeed >= kSpeedHour)
		gSpeed = kSpeedMinute; // one hour per second, "medium"
	else
		gSpeed = kSpeedRealTime; // one day per second, "fast"
	adjustTimer();
}

function stopSpeed()
{
	stopHere();
	gSpeed = 0.0;
	adjustTimer();
}

var dateOffset = 0.0;

function timeToDegrees(time)
{
	return time;
}
function relDate(base, target)
{
	target = new Date(target * 1000); // convert from seconds to date
	if (base.getDay() == target.getDay())
		return "";
	if ((base.getDay() + 1) % 7 == (target.getDay() % 7))
		return "Tomorrow";
	if ((base.getDay() + 6) % 7 == (target.getDay() % 7))
		return "Yesterday";
	return "";
}

// --------------------------------------------------------------------------------------------------------------------------------
// Now the back side
DeclareStepChild(View({
	_proto : protoImage,
	imageSrc : "logo.png",
	viewFlags : protoImage.viewFlags | vClickable,
	ViewClickScript : function(event) {
		window.widget.openURL('http://www.gandreas.com');
	},
	viewBounds : RelBounds(0,27,134,36),
	viewJustify : vjParentCenterH
}), gBack, 'logo');

DeclareStepChild(View({
	_proto : protoImage,
	imageSrc : "Widgetarium.png",
	viewFlags : protoImage.viewFlags | vClickable,
	ViewClickScript : function(event) {
			window.widget.openURL('http://projects.gandreas.com/widgetarium');
		},
	viewBounds : RelBounds(0,-55,32,32),
	viewJustify : vjParentCenterH | vjParentBottomV
}), gBack, 'wlogo');


DeclareStepChild(View({
	_proto : protoHTMLText,
	chromeStyle : "userFont chiselFont smallFont",
	text : "<center><table class='userFont chiselFont smallFont' cellspacing=0><tr><td colspan=2 align=center>Time instructions</td></tr>" +
	"<tr><td align=center>+</td><td align=center>Speed up</td></tr>" +
	"<tr><td align=center>-</td><td align=center>Slow down</td></tr>" +
	"<tr><td align=center>enter</td><td align=center>Reset</td></tr>" +
	"<tr><td align=center>space</td><td align=center>Stop</td></tr></table></center>",
	viewBounds : RelBounds(-70,80,200,200),
	viewJustify : vjParentCenterH
}), gBack, 'ruleText');

DeclareStepChild(View({
	_proto :protoDonePrefsButton,
	viewBounds : RelBounds(0,-86,60,24),
	viewJustify : vjParentCenterH | vjParentBottomV
}), gBack, 'doneButton');


DeclareStepChild(View({
	_proto : protoSelectPicker,
	pickItems : [
	{item:'AM/PM Times',value:0},
	{item:'24 Hour Times',value:1},
	],
	viewBounds : RelBounds(0,183,134,20),
	viewJustify : vjParentCenterH,
	PickActionScript : function(value) {
		SetValue(gInstanceDefaults, 'militaryTime', parseInt(value));
	},
	ViewSetupDoneScript : function() {
		protoSelectPicker.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'value', gInstanceDefaults.militaryTime);
		GetView('armillary').Dirty();
	}
}), gBack, 'timeFormat');
DeclareStepChild(View({
	_proto : protoHTMLText,
	chromeStyle : "userFont chiselFont smallFont",
	text : "Minimum Magnitude:",
	viewBounds : RelBounds(-50,5,134,20),
	viewJustify : vjSiblingLeftH | vjSiblingBottomV | vjRightH
}), gBack, 'magnitudePrompt');
DeclareStepChild(View({
	_proto : protoInputSlider,
	//viewBounds : RelBounds(0,0,134,20),
	//viewJustify : vjParentCenterH | vjSiblingBottomV,
	viewBounds : RelBounds(10,0,70,20),
	viewJustify : vjSiblingRightH | vjSiblingTopV,
	min : 2.0,
	max : 12.0,
	value : 9.0,
	step : 1.0,
	ValueChanged : function(value) {
		SetValue(gInstanceDefaults, 'showMinMagnitude', parseFloat(value) / 2.0);
		SetValue(GetView('armillary'), 'showMinMagnitude', gInstanceDefaults.showMinMagnitude);
		SetValue(GetView('magnitudePreview'), 'text', gInstanceDefaults.showMinMagnitude + "");
	},
	ViewSetupDoneScript : function() {
		protoInputCheckbox.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'value', gInstanceDefaults.showMinMagnitude * 2.0);
	}
}), gBack, 'showMinMagnitude');
DeclareStepChild(View({
	_proto : protoText,
	chromeStyle : "userFont chiselFont smallFont",
	viewBounds : RelBounds(5,0,10,20),
	viewJustify : vjSiblingRightH | vjSiblingTopV,
	ViewSetupDoneScript : function() {
		protoText.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'text', gInstanceDefaults.showMinMagnitude + "");
	}
}), gBack, 'magnitudePreview');


DeclareStepChild(View({
	_proto : protoInputCheckbox,
	//viewBounds : RelBounds(0,0,134,20),
	//viewJustify : vjParentCenterH | vjSiblingBottomV,
	viewBounds : RelBounds(70,80,134,20),
	viewJustify : vjParentCenterH,
	text : 'Show Alt Az',
	chromeStyle : "userFont chiselFont smallFont",
	buttonValue : 1, // the value when selected
	ValueChanged : function(value) {
		SetValue(gInstanceDefaults, 'showAltAz', parseInt(value));
		SetValue(GetView('armillary'), 'showAltAz', gInstanceDefaults.showAltAz);
	},
	ViewSetupDoneScript : function() {
		protoInputCheckbox.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'viewValue', gInstanceDefaults.showAltAz);
	}
}), gBack, 'showAltAz');
DeclareStepChild(View({
	_proto : protoInputCheckbox,
	viewBounds : RelBounds(0,0,134,20),
	viewJustify : vjSiblingCenterH | vjSiblingBottomV,
	text : 'Show RA Dec',
	chromeStyle : "userFont chiselFont smallFont",
	buttonValue : 1, // the value when selected
	ValueChanged : function(value) {
		SetValue(gInstanceDefaults, 'showRaDec', parseInt(value));
		SetValue(GetView('armillary'), 'showRaDec', gInstanceDefaults.showRaDec);
	},
	ViewSetupDoneScript : function() {
		protoInputCheckbox.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'viewValue', gInstanceDefaults.showRaDec);
	}
}), gBack, 'showRaDec');
DeclareStepChild(View({
	_proto : protoInputCheckbox,
	viewBounds : RelBounds(0,0,134,20),
	viewJustify : vjSiblingCenterH | vjSiblingBottomV,
	text : 'Show Circles',
	chromeStyle : "userFont chiselFont smallFont",
	buttonValue : 1, // the value when selected
	ValueChanged : function(value) {
		SetValue(gInstanceDefaults, 'showCircles', parseInt(value));
		SetValue(GetView('armillary'), 'showCircles', gInstanceDefaults.showCircles);
	},
	ViewSetupDoneScript : function() {
		protoInputCheckbox.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'viewValue', gInstanceDefaults.showCircles);
	}
}), gBack, 'showCircles');
DeclareStepChild(View({
	_proto : protoInputCheckbox,
	viewBounds : RelBounds(0,0,134,20),
	viewJustify : vjSiblingCenterH | vjSiblingBottomV,
	text : 'Show Ecliptic',
	chromeStyle : "userFont chiselFont smallFont",
	buttonValue : 1, // the value when selected
	ValueChanged : function(value) {
		SetValue(gInstanceDefaults, 'showEcliptic', parseInt(value));
		SetValue(GetView('armillary'), 'showEcliptic', gInstanceDefaults.showEcliptic);
	},
	ViewSetupDoneScript : function() {
		protoInputCheckbox.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'viewValue', gInstanceDefaults.showEcliptic);
	}
}), gBack, 'showEcliptic');
DeclareStepChild(View({
	_proto : protoInputCheckbox,
	viewBounds : RelBounds(0,0,134,20),
	viewJustify : vjSiblingCenterH | vjSiblingBottomV,
	text : 'Show Constellations',
	chromeStyle : "userFont chiselFont smallFont",
	buttonValue : 1, // the value when selected
	ValueChanged : function(value) {
		SetValue(gInstanceDefaults, 'showConstellationLines', parseInt(value));
		SetValue(GetView('armillary'), 'showConstellationLines', gInstanceDefaults.showConstellationLines);
	},
	ViewSetupDoneScript : function() {
		protoInputCheckbox.ViewSetupDoneScript.call(this);
		// check instance and global defaults
		SetValue(this, 'viewValue', gInstanceDefaults.showConstellationLines);
	}
}), gBack, 'showConstellationLines');


DeclareStepChild(View({
	_proto : protoText,
	///text : Armillary.locationLatitudeString() + ' ' + Armillary.locationLongitudeString(),
	chromeStyle : "userFont chiselFont smallFont",
	viewFlags : protoText.viewFlags | vClickable,
	ViewSetupDoneScript : function() {
		SetValue(this, 'text', GetView('armillary').viewElement.locationLatitudeString() + ' ' + GetView('armillary').viewElement.locationLongitudeString());
	},
	ViewClickScript : function(event) {
			widget.openApplication('com.apple.systempreferences');
			var script = AppleScript.scriptFromString('tell application "System Preferences" to reveal third anchor of pane id "com.apple.preference.datetime"');
			script()
		},
	viewBounds : RelBounds(0,65,200,15),
	viewJustify : vjParentCenterH | vjCenterH
}), gBack, 'latlong');
